﻿/*
<!-- Creative Commons Licence -->
<!-- ©2004-2005 Michael Robinette, ¡nkspotting.
<a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.0/"><img alt="Creative Commons Licence" border="0" src="http://creativecommons.org/images/public/somerights20.gif" /></a><br />
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.0/">Creative Commons License</a>.
-->
<!-- /Creative Commons Licence -->


<!--

<rdf:RDF xmlns="http://web.resource.org/cc/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<Work rdf:about="">
   <dc:title>WikityWidget</dc:title>
   <dc:date>2005</dc:date>
   <dc:description>A personal wiki for the Mac OS X Tiger Dashboard</dc:description>
   <dc:creator><Agent>
      <dc:title>Michael Robinette</dc:title>
   </Agent></dc:creator>
   <dc:rights><Agent>
      <dc:title>Michael Robinette</dc:title>
   </Agent></dc:rights>
   <dc:type rdf:resource="http://purl.org/dc/dcmitype/Interactive" />
   <dc:source rdf:resource="http://inkspotting.com/wikity/"/>
   <license rdf:resource="http://creativecommons.org/licenses/by-nc-sa/2.0/" />
</Work>

<License rdf:about="http://creativecommons.org/licenses/by-nc-sa/2.0/">
   <permits rdf:resource="http://web.resource.org/cc/Reproduction" />
   <permits rdf:resource="http://web.resource.org/cc/Distribution" />
   <requires rdf:resource="http://web.resource.org/cc/Notice" />
   <requires rdf:resource="http://web.resource.org/cc/Attribution" />
   <prohibits rdf:resource="http://web.resource.org/cc/CommercialUse" />
   <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
   <requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
</License>

</rdf:RDF>

-->
*/

function max(a,b) { return (a>b) ? a : b; }
function min(a,b) { return (a<b) ? a : b; }
function abs(a)   { return (a>0) ? a : -a; }


function wikiNotImplemented()
{
    alert( "not implemented" );
}

function replaceAll( str, find, replace )
{ 
    if (str.length == 0)
        return str;
    var replaced = "";
    var right = str;
    var idx = right.indexOf( find );
    while ( idx >= 0 )        
    { 
        replaced += right.substring( 0, idx ) + replace;
        right = right.substring( idx + find.length );
        idx = right.indexOf( find );
    }
    replaced += right;
    return replaced;
}

function _q( str )
{
	return replaceAll( str, "'", "''" );
}


function wikit()
{
    this.title = "";
    this.text = null;
    this.subtitle = "";
	this.created = 0;
	this.modified = 0;
}

function inkDbGetWikit( name )
{
    var w = new wikit();
    w.title = name;
    var row = InkDatabase.selectRowWithSql( "select * from wiki where title = '" + _q(name) + "';" );
    if( null == row )
	{
		return w;
	}
	var rowText = row.objectForKey( "text" );
	if( rowText != "" )
		w.text = rowText;
    return w;
}

function inkDbSaveWikit( oldName, wikit )
{
	var row;
	row = InkDatabase.selectRowWithSql( "select count(*) from wiki where title = '" + _q(oldName) + "';" );
	if( null == row )
	{
		return;
	}
	var count = row.objectAtIndex( 0 );

	if( 0 == count )
	{
		var wikiInsert = "insert into wiki( created, modified, title, text ) values( ";
		wikiInsert +=		"(select datetime('now')), (select datetime('now'))";
		wikiInsert +=		", '" + _q(wikit.title) + "', '" + _q(wikit.text) + "' );";
		var err = InkDatabase.exec( wikiInsert );
		if( null != err )
		{
			alert( "insert into wiki failed: " + err.description );
		}
	}
	else
	{
		var wikiUpdate = "update wiki set modified = (select datetime('now')), ";
		wikiUpdate +=		"title = '" + _q(wikit.title) + "', ";
		wikiUpdate +=		"text = '" + _q(wikit.text) + "' where title = '" + _q(oldName) + "';";
		var err = InkDatabase.exec( wikiUpdate );
		if( null != err )
		{
			alert( "update wiki failed: " + err.description );
		}
	}

}

function inkDbSearchWiki( searchString, searchHandler )
{
	var query = InkDatabase.queryForSql( "select title, text, created, modified from wiki where lower(title) glob lower('*" + _q(searchString) + "*') or lower(text) glob lower('*" + _q(searchString) + "*');" );
	var row;
	var foundOne = false;
	while( null != (row = query.next()) )
	{
		foundOne = true;
		var w = new wikit();
		w.title = row.objectAtIndex( 0 );
		w.text = row.objectAtIndex( 1 );
		w.created = row.objectAtIndex( 2 );
		w.modified = row.objectAtIndex( 3 );
		searchHandler.addSearchResult( w );
	}
	
	if( !foundOne )
	{
		searchHandler.nothingFound();
	}

	query.dispose();
}

function inkDbWikitExists( title )
{
	var row = InkDatabase.selectRowWithSql( "select count(*) from wiki where lower(title) = lower('" + _q(title) + "');");
	return ( 0 != row.objectAtIndex( 0 ) );
}

function inkDbDeleteWikit( title )
{
    return InkDatabase.exec( "delete from wiki where lower(title) = lower('" + _q(title) + "');");
}

function inkWikiInit()
{
	//init database
	var err = null;
   
	if( InkDatabase.tableExists( "wiki" ) )
	{
		wikiInitialized = true;
		return;
	}
	
	var wikiSchema = "create table wiki( ";
	wikiSchema = wikiSchema + "created timestamp not null, modified timestamp not null, ";
	wikiSchema = wikiSchema + "title text not null, text not null, primary key( title ) );"
			
	err = InkDatabase.exec( wikiSchema );
	if( null != err )
	{
		alert( "could not init wiki: " + err.description() );
		return;
	}
	
	this.insertDefaultWikits();
}


function inkWikiInsertDefaultWikits()
{
    
	var w = new wikit();
	w.title = "HelpIntroduction";	
	w.text = "The WikityWidget is a personal wiki for the TigerDashboard. ";
	w.text += "If you are unfamiliar with what wiki is, think of it as ";
	w.text += "a quick way to link notes together using WikityLinks.\n\n";
	w.text += "The search field will search the name and content of wikits, ";
	w.text += "and the buttons do the following: \n";
	w.text += "※ shows all wikits\n";
	w.text += "✚ creates a new wikit\n";
	w.text += "✍ starts editing a wikit\n";
	w.text += "⌫ deletes the current wikit\n";
	w.text += "✓ saves the wikit you are editing\n";
	w.text += "⏏ cancels editing a wikit";
	this.saveWikit( w.title, w );
		
		
	w.title = "WikityWidget";	
	w.text = "A personal wiki that lives in the TigerDashboard. You can find more information about wikis here: http://en.wikipedia.org/wiki/Wiki before reading about what kind of wiki this is.\n\nThis is a simple wiki coded by MichaelRobinette. The UserInterface is written entirely in JavaScript + XHTML/CSS and the storage is provided by a WebKit plugin which wraps SQLite3 ( http://sqlite.org ).\n\nMichaelRobinette has quite a few more ideas for features and he would be happy to discuss them.";		
	this.saveWikit( w.title, w );
		
		
	w.title = "TigerDashboard";
	w.text = "If you're reading this, you already know what the TigerDashboard is because you're in it. :)";
	this.saveWikit( w.title, w );
		
		
	w.title = "WikityLinks";
	w.text = "WikityLinks are automatically created from words that use a certain pattern. An uppercase letter followed by at least one lowercase letter followed by another uppercase letter. LikeThis, OrThis, OrEvenSomethingLikeThis.\n\nIn the programming world, we call that CamelNotation. However, some girlfriends think WritingLikeThisIsSilly so we'll probably have to provide an alternative LinkStyle in the future.";
	this.saveWikit( w.title, w );
		
		
	w.title = "MichaelRobinette";
	w.text = "Author of WikityWidget and a SoftwareDeveloper in LosAngeles, CA.\n\nmailto://mgrobine@inkspotting.com\nhttp://inkspotting.com";
	this.saveWikit( w.title, w );
}

function inkWiki()
{
    if( !InkDatabase )
    {
		alert( "missing InkDatabase plugin" );
	}
	
	//functions that rely on InkDatabase plugin
	this.getWikit = inkDbGetWikit;
	this.saveWikit = inkDbSaveWikit;
	this.deleteWikit = inkDbDeleteWikit;
	this.searchWiki = inkDbSearchWiki;
	this.wikitExists = inkDbWikitExists;
	
	//funtions that are pure javascript
	this.init = inkWikiInit;
	this.insertDefaultWikits = inkWikiInsertDefaultWikits;
}

function wikiDisplayNothingFound()
{
	var displayDiv = this.rootElement.getElementById( "search-results" );
	if( !displayDiv )
	{
		alert( "displayDiv is null" );
		return;
	}

	var searchLists = displayDiv.getElementsByTagName( "ul" );
	var searchList = null;
	if( !searchLists || 0 == searchLists.length )
	{
		searchList = document.createElement( "ul" );
		displayDiv.appendChild( searchList );
	}
	else
	{
		searchList = searchLists.item( 0 );
	}
	if( !searchList )
	{
		alert( "searchList is null" );
		return;
	}
	var searchListItem = document.createElement("li");
	searchListItem.appendChild(document.createTextNode("Nothing found"));
	searchList.appendChild( searchListItem );
	this.wikitScroller.setDivToScroll( searchList, 25, 177 );
}

function wikiDisplayAddSearchResult( wiki )
{
	var displayDiv = this.rootElement.getElementById( "search-results" );
	if( !displayDiv )
	{
		alert( "displayDiv is null" );
		return;
	}

	var searchLists = displayDiv.getElementsByTagName( "ul" );
	var searchList = null;
	if( !searchLists || 0 == searchLists.length )
	{
		searchList = document.createElement( "ul" );
		displayDiv.appendChild( searchList );
	}
	else
	{
		searchList = searchLists.item( 0 );
	}
	if( !searchList )
	{
		alert( "searchList is null" );
		return;
	}
	var searchListItem = document.createElement("li");
	searchListItem.appendChild( this.wikitFormatter.createWikiLink( wiki.title, wiki.title ) );
	searchList.appendChild( searchListItem );
	this.wikitScroller.setDivToScroll( searchList, 25, 177 );
}

function wikiDisplayClearSearches()
{
	var displayDiv = this.rootElement.getElementById( "search-results" );
	if( !displayDiv )
	{
		alert( "displayDiv is null" );
		return;
	}
	
	var searchLists = displayDiv.getElementsByTagName( "ul" );
	var searchList = null;
	if( searchLists && 0 != searchLists.length )
	{
		displayDiv.removeChild( searchLists.item(0) );
	}

    this.wikitScroller.setDivToScroll( null, 25, 177 );
}

function wikiDisplayInitWithFormatter( formatter )
{
	this.wikitFormatter = formatter;
	//var upScroller = document.getElementById( "upScroller" );
	//var downScroller = document.getElementById( "downScroller" );
	var scrollThumb = document.getElementById( "scrollThumb" );	
	var scrollTrack = document.getElementById("scroll-track");
	this.wikitScroller.initWithControlDivs(scrollThumb, scrollTrack);
}

function wikiDisplayShowWikit( title )
{
	var display = document.getElementById( "wikit-area" );
    if( !display )
    {
        alert( "wikit-area is null" );
        return;
    }
    while( display.childNodes.length > 0 )
		display.removeChild( display.childNodes[ 0 ] );
    var w = wiki.getWikit( title ); 
    var div = null;   
    div = this.wikitFormatter.formatWikitReadOnly( w );
    
    if( !div )
    {
        alert( "wikit is null" );
        return;
    }
    display.appendChild( div );
    this.showWikits();
    div = document.getElementById( "body" + title );
    this.wikitScroller.setDivToScroll( div, 25, 177 );
    showElement( document.getElementById( "browseToolbar" ) );
    hideElement( document.getElementById( "editToolbar" ) );
    if( widget )
    {
    	widget.setPreferenceForKey( title, widget.identifier + "-currentWikit" );
    }
    
}

function wikiDisplayEditWikit( title )
{
    var display = document.getElementById( "wikit-area" );
    if( !display )
    {
        alert( "wikit-area is null" );
        return;
    }
    while( display.childNodes.length > 0 )
		display.removeChild( display.childNodes[ 0 ] );
    var w = wiki.getWikit( title ); 
    var div = wikiController.wikitFormatter.formatWikitEditor( w );  
    
    if( !div )
    {
        alert( "wikit is null" );
        return;
    }
    display.appendChild( div );
    this.wikitScroller.setDivToScroll( null, 25, 177 );
    wikiController.showWikits();
    hideElement( document.getElementById( "browseToolbar" ) );
    showElement( document.getElementById( "editToolbar" ) );
}


function showElement( div )
{
	if( !div ) alert( "showElement: div is null" );
	div.style.visibility = "visible";
}

function hideElement( div )
{
	if( !div ) alert( "hideElement: div is null" );
	div.style.visibility = "hidden";
}

function wikiDisplayShowSearches(title)
{
    this.hideWikits();
	var searchDiv = this.rootElement.getElementById( "search-results" );
	if( !searchDiv )
	{
		alert("searchDiv is nill");
		return;
	}
	/* why is this failing? */
	var titleDiv = document.getElementById("search-title");
	if(titleDiv)
	{
		titleDiv.removeChild( titleDiv.childNodes[0] );
		titleDiv.appendChild( document.createTextNode(title) );
	}
	
	showElement( searchDiv );
}

function wikiDisplayHideSearches()
{
	searchDiv = document.getElementById( "search-results" );
	hideElement( searchDiv );
}

function wikiDisplayShowWikits()
{
    this.hideSearches();
	wikitDiv = document.getElementById( "wikit-area" );
	showElement( wikitDiv );
}

function wikiDisplayHideWikits()
{
	wikitDiv = document.getElementById( "wikit-area" );
	hideElement( wikitDiv );
}

function wikiDisplayStartScrolling( scrollUp )
{
    this.wikitScroller.startScrolling( scrollUp );
}

function wikiDisplayStopScrolling()
{
    this.wikitScroller.stopScrolling();
}

function wikiDisplay()
{
	this.rootElement = document;
	this.wikitFormatter = null;
	this.wikitScroller = new scroller();
	this.wikitScroller.height = 175;
	
	this.initWithFormatter = wikiDisplayInitWithFormatter;
	this.addSearchResult = wikiDisplayAddSearchResult;
	this.nothingFound = wikiDisplayNothingFound;
	this.clearSearches = wikiDisplayClearSearches;
	this.showSearches = wikiDisplayShowSearches;
	this.hideSearches = wikiDisplayHideSearches;
	this.showWikits = wikiDisplayShowWikits;
	this.hideWikits = wikiDisplayHideWikits;
	this.showWikit = wikiDisplayShowWikit;
	this.editWikit = wikiDisplayEditWikit;
	
	this.startScrolling = wikiDisplayStartScrolling;
	this.stopScrolling = wikiDisplayStopScrolling;
	
	this.scroll_tracker = new ScrollThumbTracker(this.wikitScroller);
	
}

function wikiFormatterCreateWikiLink( title )
{
	var link = document.createElement("a");
    link.onclick = onWikityClick;
    link.setAttribute("href","JavaScript:;");
    link.setAttribute("title", title );
	link.appendChild( document.createTextNode( title ) );

	if( wiki.wikitExists( title ) )
		link.setAttribute("class", "existingWikit");
	else
		link.setAttribute("class", "emptyWikit");
	return link;
}

function wikiFormatterCreateExternalLink( href )
{
	var link = document.createElement("a");
	if( widget )
	{
	   link.setAttribute("href","JavaScript:;");
	   link.onclick = onClickedExternalLink;
    }
    else
    {
        link.setAttribute("href", href);
    }
    link.setAttribute("title", "external link: " + href);
	link.appendChild( document.createTextNode( href ) );
	return link;
}

function wikiFormatterWikifyText( text )
{
    var upperLetter = "[A-Z]";
    var lowerLetter = "[a-z]";
    var anyLetter = "[A-Za-z_0-9]";
    var wikiLink = upperLetter + "+" + lowerLetter + "+" + upperLetter + anyLetter + "*";
    var externalUrl = "(?:http|https|mailto|ftp|feed|itms):\\S*";
    var newLine = "\\n";
    var theRegExp = new RegExp("(" + wikiLink + ")|(" + externalUrl + ")|(" + newLine + ")","mg");
    var lastMatch = 0;
	
	var wikitDiv = document.createElement( "div" );
    do {
        // Get the next match
        var theMatch = theRegExp.exec(text);
        if(theMatch)
            {
            if(theMatch.index > lastMatch)
				{
                wikitDiv.appendChild(document.createTextNode(text.substring(lastMatch,theMatch.index)));
				}
            lastMatch = theRegExp.lastIndex;
            if(theMatch[1] != null) //wikiLink
				{
                wikitDiv.appendChild( this.createWikiLink( theMatch[0] ) );
				}
            else if(theMatch[2] != null) //externalUrl
				{
                wikitDiv.appendChild( this.createExternalLink( theMatch[0] ) )
				}
            else if(theMatch[3] != null) //newLine
				{
				wikitDiv.appendChild(document.createElement("br"));        
				}    
			}
        else //no match
            {
            wikitDiv.appendChild(document.createTextNode(text.substring(lastMatch)));
            }
    } while(theMatch != null);
	return wikitDiv;
}

function createWikitDiv( w )
{
    var div = document.createElement( "div" );
    div.setAttribute( "class", "wikit" );
    div.setAttribute("id","wikit" + w.title);
    div.title = w.subtitle;

    var titleDiv = document.createElement( "div" );
    div.appendChild( titleDiv );
    titleDiv.setAttribute( "class", "title" );
    titleDiv.appendChild( document.createTextNode( w.title ) );
    titleDiv.setAttribute("id","title" + w.title);
    return(div);
}

function wikitFormatterReadOnly( w )
{
    var div = createWikitDiv( w );
    div.ondblclick = onDblClickWikit;
    var body = document.createElement( "div" );
    body.setAttribute( "class", "body" );
    body.setAttribute( "id", "body" + w.title );
    if( null == w.text )
        {
        body.style.fontStyle = "italic";
        var newWikitText = w.title + " doesn't exist. Double-click to create it.";
        body.appendChild( this.wikifyText(newWikitText) );
        }
    else
        {
        body.appendChild( this.wikifyText( w.text ) );
        }
    div.appendChild( body );
	return div;
}

function wikitFormatterEditor( w )
{
    var div = createWikitDiv( w );
    var editor = document.createElement(  "div" );
    editor.setAttribute( "class", "editor" );
    editor.setAttribute("id","editor" + w.title);
    // Create the title editor
    var title = document.createElement( "div" );
    editor.appendChild( title );
    var titleInput = document.createElement( "input" );
    title.appendChild( titleInput );
    titleInput.setAttribute("id","editorTitle" + w.title);
    titleInput.setAttribute("type","text");
    titleInput.value = w.title;
    titleInput.setAttribute("size","25");
    // Do the body
    var body = document.createElement( "div" );
    editor.appendChild( body );
    var bodyInput = document.createElement( "textarea" );
    body.appendChild( bodyInput );
    
    bodyInput.setAttribute("id","editorBody" + w.title);
    bodyInput.setAttribute("rows","11");
    bodyInput.setAttribute("cols","35");
    if( null == w.text )
        bodyInput.value = "Type the text for '" + w.title + "' here.";
    else
    	bodyInput.value = w.text;
    div.appendChild( editor );
	return div;
}

function wikitFormatterInit()
{
}

function wikitFormatter()
{
	this.init = wikitFormatterInit;
	this.wikifyText = wikiFormatterWikifyText;
	this.formatWikitReadOnly = wikitFormatterReadOnly;
	this.formatWikitEditor = wikitFormatterEditor;
	this.createWikiLink = wikiFormatterCreateWikiLink;
	this.createExternalLink = wikiFormatterCreateExternalLink;
}

// ---------------------------------------------------------------------------------
// Main
// ---------------------------------------------------------------------------------
var wiki = null;
var wikiController = null;
function main()
{
    self.scrollbars.visible = false;
	wiki = new inkWiki();
	wiki.init();
	
	var formatter = new wikitFormatter();
	formatter.init();
	
	wikiController = new wikiDisplay();
	wikiController.initWithFormatter( formatter );
	
	var startWikit = "";
	if( widget )
	{
		startWikit = widget.preferenceForKey( widget.identifier + "-currentWikit" );
	}
	if( !startWikit || startWikit == "" )
		startWikit = "HelpIntroduction";
    wikiController.showWikit( startWikit );
}

function wikiSearch( searchString )
{
	wikiController.clearSearches();
	wikiController.showSearches("SearchResults: " + searchString);
	if( searchString != "" )
		wiki.searchWiki( searchString, wikiController );
}

function onWikityClick( e )
{
    var title;
	if(this.firstChild)
        title = this.firstChild.nodeValue;
    else if (this.nodeValue)
	   title = this.nodeValue; 
	if(title)
        wikiController.showWikit( title );
}


function onClickedExternalLink( e )
{
     var url;
	if(this.firstChild)
        url = this.firstChild.nodeValue;
    else if (this.nodeValue)
	   url = this.nodeValue; 
	if(url)
        widget.openURL( url );
}


function saveWikit(title)
{
	var newWikit = new wikit();
	newWikit.title = document.getElementById("editorTitle" + title).value;
	newWikit.text = document.getElementById("editorBody" + title).value;
	wiki.saveWikit( title, newWikit );
    wikiController.showWikit( newWikit.title );
}


function onDblClickWikit(e)
{
    // Empty the current selection
    if(document.selection)
        document.selection.empty();
	var title;
	if(this.id.substr(0,5) == "wikit")
		title = this.id.substr(5);
	if(title)
        wikiController.editWikit( title );
}


function getCurrentWikitTitle()
{
    var display = document.getElementById( "wikit-area" );
    if( !display )
    {
        alert( "wikit-area is null" );
        return null;
    }
    if( display.style.visibility == "hidden" )
    {
    	alert( "no current wikit" );
    	return null;
    }
    var wikitDiv = display.firstChild;
    if(wikitDiv.id.substr(0,5) != "wikit")
    {
        alert( "firstChild is not a wikit" );
        return null;
    }
    return wikitDiv.id.substr(5);
}


function wikiBack()
{
	alert( "wikiBack not implemented yet" );
}


function wikiForward()
{
	alert( "wikiForward not implemented yet" );
}


function wikiNew()
{
    var unusedTitle = "NewWikit";
    var counter = 0;
    while( wiki.wikitExists( unusedTitle ) )
    {
        unusedTitle = "NewWikit" + (++counter);
    }
    wikiController.editWikit( unusedTitle );
}



function wikiHome()
{
	wikiCancel();
	wikiController.clearSearches();
	wikiController.showSearches("AllWikits");
	wiki.searchWiki( "*", wikiController );
}

function wikiSave()
{
    
	var title = getCurrentWikitTitle();
    
	if( null == title )    
	{
        alert("current wikit is null");
        return;
    }
    
	var newWikit = new wikit();
	newWikit.title = document.getElementById("editorTitle" + title).value;
	newWikit.text = document.getElementById("editorBody" + title).value;
	wiki.saveWikit( title, newWikit );
    wikiController.showWikit( newWikit.title );
    
}
    


function wikiDelete()
{
    var title = getCurrentWikitTitle();
    if( null == title )
    
	{
        alert("current wikit is null");
        return;
    }
    
	if( wiki.wikitExists( title ) )
    	wiki.deleteWikit( title );
		
	wikiController.showWikit( title );
}



function wikiEdit()
{
    var title = getCurrentWikitTitle();
    
	if( null == title )    
	{
        alert("current wikit is null");
        return;
    }
    
	wikiController.editWikit( title );
}


function wikiCancel()
{
    var title = getCurrentWikitTitle();
    
	if( null == title )
	{
        alert("current wikit is null");
        return;
    }
    
	wikiController.showWikit( title );
}



function scrollerInitWithControlDivs( scrollThumb, scrolltrack )
{
    this.scrollThumb = scrollThumb;
    this.scroll_track = scrolltrack;
    
}


function scrollerSetDivToScroll( div, t, h )
{
    this.divToScroll = div;
    //this.upControl.style.display = "none";
    if( null == this.divToScroll )
    {
        //this.downControl.style.display = "none";
        this.scrollThumb.style.display = "none";
        this.scroll_track.style.display = "none";
        return;
    }
    this.clipTop = t;
    this.clipHeight = h;
    
    this.divToScroll.style.position = "absolute";
    this.divToScroll.style.top = this.clipTop;
    this.scrollPos = 0;
    this.divToScroll.style.clip = "rect(0px 300px " + (this.clipHeight)  + "px 0px)";
    if ( this.clipHeight >= this.divToScroll.scrollHeight ) 
    {
        //this.downControl.style.display = "none";
        this.scrollThumb.style.display = "none";
        this.scroll_track.style.display = "none";
    } 
    else 
    {
        //this.downControl.style.display = "none";
        this.scrollThumb.style.display = "block";
     
        var h2 = this.divToScroll.scrollHeight;
        var h3 = this.clipHeight;
        var pages = h2/h3;
        var maxHeight = this.clipHeight - 80;
        var thumbHeight = maxHeight/pages;
        
        this.scroll_per_pixel = (h2 - h3)/(this.clipHeight - thumbHeight);
        this.scrollThumb.style.height = thumbHeight - 5;
        
        this.scrollThumb.style.top = 80;
        this.scrollTop = 80;
        this.max_pos = this.divToScroll.scrollHeight - this.clipHeight;
        this.min_pos = 0;
        this.max_top = this.clipHeight + 80 - thumbHeight;
        this.scroll_track.style.display="block";
        this.scroll_track.style.top = 80;
        this.scroll_track.style.height = this.max_top + thumbHeight - 80 - 5;
    }
}


function scrollerScrollTo(offset)
{
	var n = (offset*this.scroll_per_pixel);
	if( offset < 0 )
	{
		this.scrollPos = max(this.min_pos, this.scrollPos + n);
		this.scrollTop = max(80, this.scrollTop + offset );
	}
	else
	{
		this.scrollPos = min(this.max_pos, this.scrollPos + n);
		this.scrollTop = min(this.max_top, this.scrollTop + offset);
	}
		
	this.divToScroll.style.top = this.clipTop - this.scrollPos;
	this.divToScroll.style.clip = "rect(" + (this.scrollPos) +"px 300px " + (this.clipHeight + this.scrollPos)  + "px 0px)";
	this.scrollThumb.style.top = this.scrollTop;
	return (this.scrollPos != this.min_pos && this.scrollPos != this.max_pos);
 
}

function scrollerTrackMouse(event)
{
	this.clickY = event.y;
}

function scroller()
{
    this.initWithControlDivs = scrollerInitWithControlDivs;
    this.setDivToScroll = scrollerSetDivToScroll;
    this.scroll_to = scrollerScrollTo;
    this.track_mouse = function(e)
    {
    	this.mouse_tracker = new MouseTracker(e);
    }
    
    this.stepSize = 2;
    this.clipHeight = 180;
    this.clipTop = 25;
    this.scrollSpeed = 20;
    this.scrollPos = 0;
    this.scrollTimer = 0;
    this.scrollTop = 73;
    //this.upControl = null;
    //this.downControl = null;
    this.scrollThumb = null;
    this.scroll_track = null;
    this.divToScroll = null;
    this.mouse_tracker = null;
    this.scroll_per_pixel = 1;
    this.max_pos = 100;
    this.min_pos = 0;
    this.max_top = 20;
}

MouseTracker = function(e)
{
	this.mouse_down_x = e.x;
	this.mouse_down_y = e.y;
	this.current_x = e.x;
	this.current_y = e.y;
	
	this.mouse_moved = function(e2)
	{
		this.current_x = e2.x;
		this.current_y = e2.y;
	}
}

ScrollThumbTracker = function(scroller)
{
	this.scroller = scroller;
	mouse_up = function(e)
	{
		document.removeEventListener("mousemove", mouse_move, true); 
    	document.removeEventListener("mouseup", mouse_up, true);
	}
	
	mouse_move = function(e)
	{
		if(!scroller) {alert("null scroller"); return;}
		if(scroller.scroll_to(e.y - scroller.mouse_tracker.current_y))
			scroller.mouse_tracker.mouse_moved(e);
	}
	
	this.start_tracking = function(e)
	{
		this.scroller.track_mouse(e);
		document.addEventListener("mousemove", mouse_move, true); 
		document.addEventListener("mouseup", mouse_up, true); 
	}
	
}


function startTrackingScroll(e)
{
	wikiController.scroll_tracker.start_tracking(e)
}

function scrollpage(e)
{
	var n = e.y - wikiController.wikitScroller.scrollTop;
	var x = wikiController.wikitScroller.scroll_per_pixel;
	if(n<0)
		n = (1/x)*-wikiController.wikitScroller.clipHeight;
	else
		n = (1/x)*wikiController.wikitScroller.clipHeight;
		
	wikiController.wikitScroller.scroll_to(n);
}



